(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

BeginPackage["WBCorr`"]

Needs["LinearAlgebra`MatrixManipulation`"]

Needs["LinearAlgebra`Orthogonalization`"]

Needs["Statistics`DescriptiveStatistics`"]

Needs["Statistics`MultiDescriptiveStatistics`"]

Needs["Statistics`DataManipulation`"]

Needs["Statistics`ContinuousDistributions`"]

ComputeChiSquare::usage="ComputeChiSquare[data,hypothesis,samplesize] \
computes an asymptotic chi-square test statistic for correlational pattern \
hypotheses. data is a list containing data to be analyzed, hypothesis is a \
hypothesis matrix constructed according to the method specified in Steiger \
(2004), and samplesize is a list of sample sizes. Options include DataType, \
EstimationMethod, PrintOutput, Diagnostics."

Compute4thOrderMoments::usage="Dummy"

MakeSymmetricMatrix::usage="Dummy"

\[Rho]::usage="Dummy"

MardiaMultivariateSkewnessStat::usage="Dummy"

DataType::usage="DataType specifies the type of data to be analyzed. DataType \
options are CorrelationMatrixData and RawData. CorrelationMatrixData is the \
dafault."

EstimationMethod::usage="Selects estimation for the asymptotic chi-square \
statistic. Options are GLS,ADF,TSGLS,TSADF. These are explained in the \
article by Steiger (2004)"

PrintOutput::usage="PrintOutput controls the type of output. Options are \
Regular and Minimal. Default is Regular."

Diagnostics::usage="Diagnostics controls the printing of diagnostic messages \
during output. Options are True and False. Default is False."

Options[ComputeChiSquare]={EstimationMethod->TSGLS,
    DataType\[Rule]CorrelationMatrixData,PrintOutput\[Rule]Regular,
    Diagnostics\[Rule]False}

Begin["`Private`"]

PMatrix[A_]:=A.Inverse[Transpose[A].A].Transpose[A]

QMatrix[A_]:= IdentityMatrix[Part[Dimensions[A],1]]-PMatrix[A]

PhiMatrix[A_]:=Transpose[RemoveNullRows[GramSchmidt[QMatrix[A]]]]

RemoveNullRows[A_]:=Module[{c,d,p,ct,i},ct=0;
    p=Dimensions[A][[1]];
    Do[c=TakeRows[A,{i,i}];
      If[(c.Transpose[c])[[1,1]]>0,ct++;
        If[ct\[Equal]1,d=c,d=AppendColumns[d,c]]],{i,1,p}];Return[d]
    ]

findpos[i_,j_,k_,h_]:=Module[{list,a,b,c,d,pos},list=Sort[{i,j,k,h},Greater];
    a=list[[1]];b=list[[2]];c=list[[3]];d=list[[4]];
    pos=(a-1)*(a)*(a+1)*(a+2)/24 + (b-1)b(b+1)/6+ c(c-1)/2+d;
    Return[pos]]

MakeDeltaFromHypothesis::holeinlist="Free parameters in your hypothesis are \
not numbered consecutively from 1 to n. The hypothesis will be modified for \
internal calculations."

MakeDeltaFromHypothesis[hypothesis_]:=
  Module[{rows,cols,D,i,j,parlist,numberOfParameters,test1,index},
    rows= Dimensions[hypothesis][[1]];
    cols=Dimensions[hypothesis][[2]];
    parlist =Union[ Flatten[TakeColumns[hypothesis,{4,4}]]];
    If[parlist[[1]]\[Equal]0,parlist=Delete[parlist,1]];
    test1=False;
    numberOfParameters=Dimensions[parlist][[1]];
    If[numberOfParameters \[Equal] 0, Return[{}]];
    Do[If[parlist[[i]]\[NotEqual]i,test1=True],{i,1,numberOfParameters}];
    If[test1,Message[MakeDeltaFromHypothesis::holeinlist]];
    D=Array[delta,{rows,numberOfParameters}];
    Do[index =hypothesis[[i,4]];
      If[index \[Equal]parlist[ [j]],D[[i,j]]=1,D[[i,j]]=0],{i,1,rows},{j,1,
        numberOfParameters}];
    Return[D]]

MakeRhoStarFromHypothesis[hypothesis_]:=Module[{X,rows,x},
    rows= Dimensions[hypothesis][[1]];
    X=Array[x,{rows,1}];
    Do[If[hypothesis[[i,4]]\[Equal]0,X[[i,1]]=hypothesis[[i,5]],
        X[[i,1]]=0],{i,1,rows}];
    Return[X]]

MakeNMatrix[NList_,hypothesis_]:=
  Module[{rows,NMatrix,x,i},rows= Dimensions[hypothesis][[1]];
    NMatrix=Array[x,{rows}];
    Do[NMatrix[[i]]=NList[[hypothesis[[i,1]]]]-1,
      {i,1,rows}];Return[NMatrix]]

GetVecR[RList_,hypothesis_]:=
  Module[{vecr,rows,x,i,rmatrix},rows=Dimensions[hypothesis][[1]];
    vecr=Array[x,{rows}];
     Do[vecr[[i]]=
        RList[[hypothesis[[i,1]]]][[hypothesis[[i,2]],hypothesis[[i,3]]]],{i,
        rows}];
    Return[vecr]]

MakeSymmetricMatrix[R_]:=
  Module[{RR,r,p,i,j},p=Dimensions[R][[1]];RR=Array[r,{p,p}];
    Do[RR[[i,j]]=R[[i,j]];RR[[j,i]]=R[[i,j]],{i,1,p},{j,1,i}];
    Return[RR]]

compute4thOrderMoments[data_]:=
  Module[{means,sds,moments,n,p,i,j,k,h,a,b,q,zscores,x,z},
    n=Dimensions[data][[1]];p=Dimensions[data][[2]];means=Array[x,{p}];
    sds=Array[x,{p}];zscores=Array[z,{n,p}];
    (* Need to check for p<2 *)
    Do[means[[i]]=Mean[Column[data,i]];
      sds[[i]]=StandardDeviation[Column[data,i]],{i,1,p}];
    Do[zscores[[i,j]]=(data[[i,j]]-means[[j]])/sds[[j]],{i,1,n},{j,1,p}];
    q=p*(p+1)*(p+2)*(p+3)/24;
    moments=ZeroMatrix[q,1];
    a=0;
    Do[a++;Do[
        moments[[a]]=
          moments[[a]]+
            zscores[[b,i]]*zscores[[b,j]]*zscores[[b,k]]*zscores[[b,h]],{b,1,
          n}],{i,1,p},{j,1,i},{k,1,j},{h,1,k}];
    Return[moments/(n-1)]]

\!\(PearsonFilon[i_, j_, k_, h_, 
      R_] := \((1/2)\) R[\([i, j]\)] 
        R[\([k, h]\)] \((R[\([i, k]\)]\^2 + R[\([i, h]\)]\^2 + 
            R[\([j, k]\)]\^2 + R[\([j, h]\)]\^2)\) + 
      R[\([i, k]\)] R[\([j, h]\)] + R[\([i, h]\)] R[\([j, k]\)] - 
      R[\([i, j]\)] \((R[\([j, k]\)] R[\([j, h]\)] + 
            R[\([i, k]\)] R[\([i, h]\)])\) - 
      R[\([k, h]\)] \((R[\([j, k]\)] R[\([i, k]\)] + 
            R[\([j, h]\)] R[\([i, h]\)])\)\)

\[Rho][i_,j_,k_,h_,M_]:=M[[findpos[i,j,k,h],1]]

\!\(SteigerHakstian[i_, j_, k_, h_, R_, 
      M_] := \[Rho][i, j, k, h, M] + \(1\/4\) R[\([i, j]\)] 
        R[\([k, h]\)] \((\[Rho][i, i, k, k, M] + \[Rho][j, j, k, k, 
              M] + \[Rho][i, i, h, h, M] + \[Rho][j, j, h, h, 
              M])\) - \(1\/2\) 
        R[\([i, j]\)] \((\[Rho][i, i, k, h, M] + \[Rho][j, j, k, h, 
              M])\) - \(1\/2\) 
        R[\([k, h]\)] \((\[Rho][i, j, k, k, M] + \[Rho][i, j, h, h, M])\)\)

nCov[a_,i_,j_,b_,k_,h_,Rlist_]:=
  Module[{cov},If[a\[NotEqual]b,cov=0,cov=PearsonFilon[i,j,k,h,Rlist[[a]] ]];
    Return[cov]]

ComputeWLS[VecR_,Delta_,RhoStar_,nMatrix_]:=Module[{},
    If[Dimensions[Delta][[1]]\[Equal]0,Return[{}],
      Return[ 
        Inverse[Transpose[Delta].nMatrix.Delta].Transpose[
            Delta].nMatrix.(VecR-RhoStar)]]]

adfCov[a_,i_,j_,b_,k_,h_,R_,moments_]:=
  Module[{cov},
    If[a\[NotEqual]b,cov=0,
      cov=SteigerHakstian[i,j,k,h,R[[a]] ,moments[[a]]]];
    Return[cov]]

SameName[A_,B_]:=SymbolName[A]\[Equal]SymbolName[B]

BoldPrint[text_]:=Print[StyleForm[text,"Subsubsection"]];

\!\(\*
  RowBox[{\(ComputeChiSquare[data_, hypothesis_, NList_: {25}, opts___Rule]\),
     ":=", 
    RowBox[{"Module", 
      AdjustmentBox["[",
        BoxMargins->{{-0.079602, 0.079602}, {0, 0}}], \({RRList, gammahatWLS, 
        A, nMatrix, VecR, delta, rhostar, rstar, RWLSList, rows, WLSVec, m, 
        k, i, j, h, a, b, jj, kk, gammahatGLS, OmegaHatInverse, e, df, RList, 
        moments, r, nodelta, gammahatDisplay, pars, parlist, printout, 
        covgamma, estimationmethod, datatype, diagnostics, MardiaSK, 
        MardiaKU, sk, ku, 
        nList}, \[IndentingNewLine]estimationmethod = \(EstimationMethod\  \
/. \ {opts}\)\  /. \ 
          Options[ComputeChiSquare]; \[IndentingNewLine]datatype = \(DataType\
\  /. \ {opts}\)\  /. \ 
          Options[ComputeChiSquare]; \[IndentingNewLine]printoutput = \
\(PrintOutput /. \ {opts}\)\  /. \ 
          Options[ComputeChiSquare]; \[IndentingNewLine]diagnostics = \
\(Diagnostics /. \ {opts}\)\  /. \ 
          Options[ComputeChiSquare]; \[IndentingNewLine]A = \(Dimensions[
            data]\)[\([1]\)]; 
      If[diagnostics, 
        Print["\<Diagnostics = \>", diagnostics]]; \[IndentingNewLine]If[
        SameName[datatype, RawData], RList = Array[r, {A}]; 
        Do[\[IndentingNewLine]RList[\([jj]\)] = 
            CorrelationMatrix[\[IndentingNewLine]data[\([jj]\)]\
\[IndentingNewLine]], {jj, 1, A}], RList = data]; \[IndentingNewLine]If[
        SameName[datatype, RawData], 
        moments = Array[r, {A}]; \[IndentingNewLine]Do[
          moments[\([jj]\)] = compute4thOrderMoments[data[\([jj]\)]], {jj, 1, 
            A}]]; \[IndentingNewLine]If[
        SameName[datatype, RawData], \[IndentingNewLine]MardiaSK = 
          Array[r, {A, 4}]; \[IndentingNewLine]Do[
          MardiaSK[\([jj, 1]\)] = MultivariateSkewness[data[\([jj]\)]]; 
          sk = MardiaMultivariateSkewnessStat[
              MardiaSK[\([jj, 1]\)], \(Dimensions[
                  data[\([jj]\)]]\)[\([1]\)], \(Dimensions[
                  data[\([jj]\)]]\)[\([2]\)]]; 
          MardiaSK[\([jj, 2]\)] = 
            sk[\([1]\)]; \[IndentingNewLine]MardiaSK[\([jj, 3]\)] = 
            sk[\([2]\)]; \[IndentingNewLine]MardiaSK[\([jj, 4]\)] = 
            1 - CDF[ChiSquareDistribution[sk[\([2]\)]], sk[\([1]\)]], {jj, 1, 
            A}]]; \[IndentingNewLine]If[
        SameName[datatype, RawData], \[IndentingNewLine]MardiaKU = 
          Array[r, {A, 3}]; \[IndentingNewLine]Do[
          MardiaKU[\([jj, 1]\)] = MultivariateKurtosis[data[\([jj]\)]]; 
          ku = MardiaMultivariateKurtosisStat[
              MardiaKU[\([jj, 1]\)], \(Dimensions[
                  data[\([jj]\)]]\)[\([1]\)], \(Dimensions[
                  data[\([jj]\)]]\)[\([2]\)]]; 
          MardiaKU[\([jj, 2]\)] = 
            ku; \[IndentingNewLine]MardiaKU[\([jj, 3]\)] = 
            2 \((1 - CDF[NormalDistribution[0, 1], ku])\), {jj, 1, 
            A}]]; \[IndentingNewLine]VecR = 
        GetVecR[RList, 
          hypothesis]; \[IndentingNewLine]rows = \(Dimensions[
            hypothesis]\)[\([1]\)]; \[IndentingNewLine]RRList = 
        Array[r, {A}]; \[IndentingNewLine]RWLSList = 
        Array[r, {A}]; \[IndentingNewLine]Do[
        RRList[\([i]\)] = MakeSymmetricMatrix[RList[\([i]\)]], {i, 1, 
          A}]; \[IndentingNewLine]If[diagnostics, 
        Print["\<Computing NList\>"]]; \[IndentingNewLine]If[
        SameName[datatype, RawData], \[IndentingNewLine]\ \ \ \ \ \ nList = 
          Array[r, {A}]; \[IndentingNewLine]\ \ \ \ \ \ Do[
          nList[\([i]\)] = \(Dimensions[data[\([i]\)]]\)[\([1]\)], {i, 1, 
            A}], nList = 
          NList\[IndentingNewLine]\ \ ]; \[IndentingNewLine]nMatrix = 
        DiagonalMatrix[MakeNMatrix[nList, hypothesis]]; \[IndentingNewLine]If[
        diagnostics, 
        Print["\<nMatrix = \>", 
          MatrixForm[nMatrix]]]; \[IndentingNewLine]delta = 
        MakeDeltaFromHypothesis[hypothesis]; \[IndentingNewLine]If[
        diagnostics, 
        Print["\<Computing delta\>"]]; \[IndentingNewLine]nodelta = \
\(Dimensions[delta]\)[\([1]\)] \[Equal] 0; \[IndentingNewLine]rhostar = 
        MakeRhoStarFromHypothesis[
          hypothesis]; \[IndentingNewLine]gammahatWLS\  = \ 
        ComputeWLS[VecR, delta, rhostar, nMatrix]; \[IndentingNewLine]If[
        nodelta, WLSVec = rhostar, 
        WLSVec = 
          delta . gammahatWLS\  + \ rhostar]; \[IndentingNewLine]RWLSList = 
        RRList; \[IndentingNewLine]Do[a = hypothesis[\([k, 1]\)]; 
        i = hypothesis[\([k, 2]\)]; j = hypothesis[\([k, 3]\)]; 
        RWLSList[\([a, i, j]\)] = WLSVec[\([k, 1]\)]; 
        RWLSList[\([a, j, i]\)] = WLSVec[\([k, 1]\)], {k, 1, 
          rows}]; \[IndentingNewLine]Psi = 
        Array[x, {rows, rows}]; \[IndentingNewLine]Do[
        a = hypothesis[\([jj, 1]\)]; b = hypothesis[\([kk, 1]\)]; 
        i = hypothesis[\([jj, 2]\)]; 
        j = hypothesis[\([jj, 3]\)]; \[IndentingNewLine]b = 
          hypothesis[\([kk, 1]\)]; k = hypothesis[\([kk, 2]\)]; 
        h = hypothesis[\([kk, 3]\)]; 
        Psi[\([jj, kk]\)] = 
          Which[SameName[estimationmethod, TSGLS], 
            nCov[a, i, j, b, k, h, RWLSList], \[IndentingNewLine]SameName[
              estimationmethod, GLS], 
            nCov[a, i, j, b, k, h, RList], \[IndentingNewLine]SameName[
              estimationmethod, ADF], 
            adfCov[a, i, j, b, k, h, RList, 
              moments], \[IndentingNewLine]SameName[estimationmethod, TSADF], 
            adfCov[a, i, j, b, k, h, RWLSList, 
              moments]]; \[IndentingNewLine]Psi[\([kk, jj]\)] = 
          Psi[\([jj, kk]\)], {jj, 1, rows}, {kk, 1, 
          jj}]; \[IndentingNewLine]If[diagnostics, 
        Print["\<Computing OmegaHatInverse\>"]]; \
\[IndentingNewLine]OmegaHatInverse\  = \ 
        Sqrt[nMatrix] . Inverse[Psi] . Sqrt[nMatrix]; \[IndentingNewLine]If[
        delta \[NotEqual] {}, 
        Psi = Transpose[delta] . OmegaHatInverse]; \[IndentingNewLine]rstar = 
        VecR - rhostar; \[IndentingNewLine]If[delta == {}, 
        e = rstar - rhostar, covgamma = Inverse[Psi . delta]; 
        gammahatGLS = covgamma . Psi . rstar; \[IndentingNewLine]e = 
          rstar - delta . gammahatGLS]; \[IndentingNewLine]If[diagnostics, 
        Print["\<Computing test statistic\>"]]; \[IndentingNewLine]fGLS = \
\((Transpose[e] . OmegaHatInverse . e)\)[\([1, 1]\)]; \[IndentingNewLine]If[
        diagnostics, 
        Print["\<Computing number of parameters\>"]]; \[IndentingNewLine]If[
        delta \[Equal] {}, pars = 0, 
        pars = \(Dimensions[gammahatGLS]\)[\([1]\)]]; \[IndentingNewLine]If[
        diagnostics, Print["\<Computing df\>"]]; \[IndentingNewLine]If[
        nodelta, \ df = rows, df = rows - pars]; \[IndentingNewLine]If[
        SameName[printoutput, Regular], 
        Print[StyleForm["\<WBCORR Output\>", "\<Subsection\>"]]; 
        BoldPrint["\<Hypothesis Matrix\>"]; \[IndentingNewLine]Print[
          TableForm[hypothesis, 
            TableHeadings \[Rule] {None, {"\<Group\>", "\<Row\>", \
"\<Column\>", "\<Parameter Tag\>", "\<Fixed Value\>"}}]]; \
\[IndentingNewLine]Do[
          BoldPrint[
            SequenceForm["\<Input Correlation Matrix \>", 
              i, \ "\<   Sample Size = \>", NList[\([i]\)]]]; 
          Print[MatrixForm[RRList[\([i]\)]]], {i, 1, 
            A}]; \[IndentingNewLine]Do[
          BoldPrint[
            SequenceForm["\<OLS Estimates of Correlation Matrix \>", i]]; 
          Print[MatrixForm[RWLSList[\([i]\)]]], {i, 1, 
            A}]; \[IndentingNewLine]If[
          pars\  > 0, \[IndentingNewLine]gammahatDisplay\  = \ 
            Array[r, {pars, 3}]; \[IndentingNewLine]parlist\  = 
            Union[\ Flatten[
                TakeColumns[hypothesis, {4, 4}]]]; \[IndentingNewLine]Do[
            gammahatDisplay[\([i, 1]\)] = parlist[\([i]\)]; 
            gammahatDisplay[\([i, 2]\)] = gammahatGLS[\([i, 1]\)]; 
            gammahatDisplay[\([i, 3]\)] = \@covgamma[\([i, i]\)], {i, 1, 
              pars}]; \[IndentingNewLine]Which[
            SameName[estimationmethod, GLS], 
            BoldPrint["\<GLS Parameter Estimates\>"], \
\[IndentingNewLine]SameName[estimationmethod, TSGLS], 
            BoldPrint["\<2-Stage GLS Parameter Estimates\>"], 
            SameName[estimationmethod, ADF], \ 
            BoldPrint["\<ADF Parameter Estimates\>"], \ 
            SameName[estimationmethod, TSADF], 
            BoldPrint["\<2-Stage ADF Parameter Estimates\>"]]; \
\[IndentingNewLine]Print[
            TableForm[gammahatDisplay, 
              TableHeadings -> {None, {"\<Parameter Tag\>", "\<Estimate\>", "\
\<Standard Error\>"}}]];]; \[IndentingNewLine]BoldPrint["\<Significance Test \
Results\>"]; \[IndentingNewLine]Print[
          TableForm[{{fGLS, df, 1 - CDF[ChiSquareDistribution[df], fGLS]}}, 
            TableHeadings \[Rule] {None, {"\<Chi Square\>", "\<df\>", \
"\<plevel\>"}}]]; \[IndentingNewLine]If[
          SameName[datatype, 
            RawData], \[IndentingNewLine]BoldPrint["\<Assessment of \
Multivariate Normality\>"]; \[IndentingNewLine]Print[
            TableForm[MardiaSK, 
              TableHeadings \[Rule] {Automatic, {"\<Multivariate Skewness\>", \
"\<Chi Square\>", "\<df\>", "\<plevel\>"}}]]; \[IndentingNewLine]Print[
            TableForm[MardiaKU, 
              TableHeadings \[Rule] {Automatic, {"\<Multivariate Kurtosis\>", \
"\<Z\>", "\<plevel (2-tailed)\>"}}]];]; \[IndentingNewLine]Return[]]; \
\[IndentingNewLine]If[SameName[printoutput, Minimal], 
        BoldPrint["\<Significance Test Results\>"]; \[IndentingNewLine]Print[
          TableForm[{{fGLS, df, 1 - CDF[ChiSquareDistribution[df], fGLS]}}, 
            TableHeadings \[Rule] {None, {"\<Chi Square\>", "\<df\>", \
"\<plevel\>"}}]]; Return[]]; \[IndentingNewLine]Return[{fGLS, df}]\), 
      "\[IndentingNewLine]", "]"}]}]\)













MakeHypothesisForEqualityOfIndependentMatrices[A_,p_]:=
  Module[{H,pos,a,i,j},H=Array[h,{p(p-1),5}];pos=0;
    Do[pos++;H[[pos,1]]=a;H[[pos,2]]=i;H[[pos,3]]=j;H[[pos,4]]=(i-1)(i-2)/2+j;
      H[[pos,5]]=0,{a,1,A},{i,2,p},{j,1,i-1}];
    Return[H]
    ]

EfficientComputeTSGLS[data_,NList_,hypothesis_,stages_,rawdata_]:=
  Module[{RRList,gammahatWLS,A,nMatrix,VecR,delta,rhostar,rstar,RWLSList,rows,
      WLSVec,m,k,i,j,h,a,b,jj,kk,gammahatGLS,U,\[CapitalPhi],e,df,RList,
      moments,r,PhiPrimeUPhi,bVector,yVector,eVector},
    A=Dimensions[data][[1]];If[rawdata,RList=Array[r,{A}];Do[
        RList[[jj]]=CorrelationMatrix[
            data[[jj]]
            ],{jj,1,A}],RList=data];
    If[rawdata,moments=Array[r,{A}];
      Do[moments[[jj]]=compute4thOrderMoments[data[[jj]]],{jj,1,A}]];
    Print["Got Correlations and Moments"];
    VecR=GetVecR[RList,hypothesis];
    rows=Dimensions[hypothesis][[1]];
    RRList=Array[r,{A}];
    RWLSList=Array[r,{A}];
    Print["Setting Up RRLIST and RWLSLIST"];
    Do[RRList[[i]]=MakeSymmetricMatrix[RList[[i]]],{i,1,A}];
    Print["RRList OK"];
    nMatrix=DiagonalMatrix[MakeNMatrix[NList,hypothesis]];
    Print["nMatrix OK"];
    delta=MakeDeltaFromHypothesis[hypothesis];
    rhostar=MakeRhoStarFromHypothesis[hypothesis];
    gammahatWLS = ComputeWLS[VecR,delta,rhostar,nMatrix];
    WLSVec=delta.gammahatWLS + rhostar;
    RWLSList=RRList;
    Print["RWLSList OK"];
    Do[a=hypothesis[[k,1]];i=hypothesis[[k,2]];j=hypothesis[[k,3]];
      RWLSList[[a,i,j]]=WLSVec[[k,1]];
      RWLSList[[a,j,i]]=WLSVec[[k,1]],{k,1,rows}];
    Psi=Array[x,{rows,rows}];
    Print["Setting Up Psi"];
    Do[a=hypothesis[[jj,1]];b=hypothesis[[kk,1]];i=hypothesis[[jj,2]];
      j=hypothesis[[jj,3]];
      b=hypothesis[[kk,1]];k=hypothesis[[kk,2]];h=hypothesis[[kk,3]];
      Psi[[jj,kk]]=
        Which[stages==2,nCov[a,i,j,b,k,h,RWLSList],stages==1,
          nCov[a,i,j,b,k,h,RList],stages\[Equal]-1,
          adfCov[a,i,j,b,k,h,RList,moments],stages\[Equal]-2,
          adfCov[a,i,j,b,k,h,RWLSList,moments]];
      Psi[[kk,jj]]=Psi[[jj,kk]],{jj,1,rows},{kk,1,jj}];
    Print["Psi =",MatrixForm[Psi]];
    rstar=VecR-rhostar;
    U=Inverse[nMatrix].Psi;
    \[CapitalPhi]=PhiMatrix[delta];
    PhiPrimeUPhi=Transpose[\[CapitalPhi]].U.\[CapitalPhi];
    bVector=Transpose[\[CapitalPhi]].VecR;
    yVector=LinearSolve[PhiPrimeUPhi,bVector];
    eVector=U.\[CapitalPhi].yVector;
    gammahatGLS=
      Inverse[Transpose[delta].delta].Transpose[delta].(rstar-eVector);
    fGLS=bVector.yVector;
    df=rows-Dimensions[gammahatGLS][[1]];
    Return[fGLS]]





\!\(MardiaCoefficients[data_] := 
    Module[{b1p, b2p, n, xbar, s, sinv, rij, i, j, xi, xj, xplus}, 
      n = \(Dimensions[data]\)[\([1]\)]; 
      xbar = Mean[data]; \[IndentingNewLine]s = CovarianceMatrixMLE[data]; 
      sinv = Inverse[s]; b1p = 0; b2p = 0; 
      Do[xi = data[\([i]\)] - xbar; xplus = xi . sinv; 
        b2p += \((xplus . xi)\)\^2; 
        Do[xj = data[\([j]\)] - xbar; 
          b1p += \((xplus . xj)\)\^3, {j, 1, n}], {i, 1, n}]; b2p = b2p/n; 
      b1p = b1p/n\^2; Return[{b1p, b2p}]\[IndentingNewLine]]\)

\!\(MardiaMultivariateKurtosisStat[data_] := 
    Module[{n, p}, n = \(Dimensions[data]\)[\([1]\)]; 
      p = \(Dimensions[data]\)[\([2]\)]; 
      Return[\((MultivariateKurtosis[
                data] - \((p \((p + 
                      2)\) \((n - 1)\)/\((n + 
                        1)\))\))\)/\@\(8\ p\ \((p + 2)\)/n\)]\
\[IndentingNewLine]]\)

MardiaMultivariateSkewness[data_]:=N[MultivariateSkewness[data]]

MardiaMultivariateKurtosis[data_]:=N[MultivariateKurtosis[data]]

\!\(MardiaMultivariateSkewnessStat[data_] := 
    Module[{A, n, p, df}, n = \(Dimensions[data]\)[\([1]\)]; 
      p = \(Dimensions[data]\)[\([2]\)]; 
      A = \(1\/6\) n\ MardiaMultivariateSkewness[data]; 
      df = p \((p + 1)\) \((p + 2)\)/6; Return[{A, df}]]\)

\!\(MardiaMultivariateKurtosisStat[b2p_, n_, 
      p_] := \((b2p - \((p \((p + 
                  2)\) \((n - 1)\)/\((n + 
                    1)\))\))\)/\@\(8\ p\ \((p + 2)\)/n\)\)

\!\(MardiaMultivariateSkewnessStat[b1p_, n_, p_] := 
    Module[{A, df}, A = \(1\/6\) n\ b1p; df = p \((p + 1)\) \((p + 2)\)/6; 
      Return[{A, df}]]\)

End[]





EndPackage[]